# -*- coding:utf-8 -*-
import os
import platform
import shutil
import stat
from optparse import OptionParser

TIZEN____ = "tizen_3.0"


class CpFile:
    sep = os.sep
    #linux目标路径
    TARGET_BASE_PATH_LINUX = os.path.join(os.sep + "opt", "tct")
    TARGET_BASE_LITE_LINUX = os.path.join(os.sep + "opt", "testkit")
    #windows目标路径
    TARGET_BASE_PATH_WINDOWS = os.path.join("C:\\opt", "tct")
    TARGET_BASE_LITE_WINDOWS = os.path.join("C:\\opt", "testkit")

    CURRENT_TARGET_BASE_PATH = ""
    CURRENT_TARGET_LITE_PATH = ""
    CURRENT_SOURCE_LITE_PATH = ""

    #shell
    SOURCE_SHELL_PATH =  sep + "shell"
    TARGET_SHELL_PATH = sep + TIZEN____ + sep + "shell"
    #manager
    SOURCE_MANAGER_PATH = ".." + sep + "tools" + sep + "manager"
    TARGET_MANAGER_PATH = sep + TIZEN____ + sep + "manager"
    #package
    SOURCE_PACKAGE_PATH = ".." + sep + "package"
    TARGET_PACKAGE_PATH = sep + TIZEN____ + sep + "packages"
    #resource
    SOURCE_RESOURCE_PATH = ".." + sep + "resource"
    TARGET_RESOURCE_PATH = sep + TIZEN____ + sep + "resource"
    #script
    SOURCE_SCRIPT_PATH = ".." + sep + "tools"
    TARGET_SCRIPT_PATH = sep + TIZEN____ + sep + "scripts"
    #doc
    SOURCE_DOC_PATH = ".." + sep + "doc"
    TARGET_DOC_PATH = sep + TIZEN____ + sep + "doc"
    #testkit
    SOURCE_TESTKIT_PATH = sep + "testkitlite"
    TARGET_TESTKIT_PATH = sep + "lite"

    def getCurrentOSBit(self):
        os.system("chmod 777 /opt")
        return platform.architecture()

    def setCurrentPath(self):
        self.CURRENT_SOURCE_BASE_PATH = os.getcwd() + self.sep
        if (platform.system() == "Windows"):
            self.CURRENT_TARGET_BASE_PATH = self.TARGET_BASE_PATH_WINDOWS
            self.CURRENT_TARGET_LITE_PATH = self.TARGET_BASE_LITE_WINDOWS
        else:
            self.CURRENT_TARGET_BASE_PATH = self.TARGET_BASE_PATH_LINUX
            self.CURRENT_TARGET_LITE_PATH = self.TARGET_BASE_LITE_LINUX
        print("current source base path =" + self.CURRENT_SOURCE_BASE_PATH)
        print("current target base path =" + self.CURRENT_TARGET_BASE_PATH)

    def cpSdb(self):
        osInfo = self.getCurrentOSBit()
        if (platform.system() == "Windows"):
            if (str(osInfo[0]).find("64") != -1):
                self.cpFile(
                    self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "sdb" + self.sep + "sdb-64.exe",
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + "sdb.exe")
            if (str(osInfo[0]).find("32") != -1):
                self.cpFile(
                    self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "sdb" + self.sep + "sdb-32.exe",
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + "sdb.exe")
        else:
            if (str(osInfo[0]).find("64") != -1):
                self.cpFile(
                    self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "sdb" + self.sep + "sdb-64",
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + "sdb")
            if (str(osInfo[0]).find("32") != -1):
                self.cpFile(
                    self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "sdb" + self.sep + "sdb-32",
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + "sdb")

    def cpOtherFiles(self):
        tct_mgr = "tct-mgr"
        tct_shell = "tct-shell"
        testkit_lite = "testkit-lite"

        if (platform.system() == "Windows"):
            tct_mgr = "tct-mgr.bat"
            tct_shell = "tct-shell.bat"
            testkit_lite = "testkit-lite.bat"

        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + tct_mgr,
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + tct_mgr)
        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + tct_shell,
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + tct_shell)
        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + testkit_lite,
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + testkit_lite)
        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "full_pkg_generator",
                    self.CURRENT_TARGET_BASE_PATH + self.sep + TIZEN____ + self.sep + "full_pkg_generator")

    def cpTestKitLite(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_TESTKIT_PATH,
                   self.CURRENT_TARGET_LITE_PATH + self.TARGET_TESTKIT_PATH, "lite")
        for r,d,f in os.walk(self.CURRENT_TARGET_LITE_PATH + self.TARGET_TESTKIT_PATH):
            os.chmod(r, stat.S_IRWXU | stat.S_IRWXG | stat.S_IRWXO)

    def cpDoc(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_DOC_PATH,
                   self.CURRENT_TARGET_BASE_PATH + self.TARGET_DOC_PATH, "doc")

    def cpScript(self):
        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "healthcheck.ini",
                    self.CURRENT_TARGET_BASE_PATH + self.TARGET_SCRIPT_PATH + self.sep + "healthcheck.ini")
        self.cpFile(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SCRIPT_PATH + self.sep + "tct-config-device.py",
                    self.CURRENT_TARGET_BASE_PATH + self.TARGET_SCRIPT_PATH + self.sep + "tct-config-device.py")

    def cpResource(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_RESOURCE_PATH,
                   self.CURRENT_TARGET_BASE_PATH + self.TARGET_RESOURCE_PATH, "resource")

    def cpPackage(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_PACKAGE_PATH,
                   self.CURRENT_TARGET_BASE_PATH + self.TARGET_PACKAGE_PATH, "package")

    def cpManager(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_MANAGER_PATH,
                   self.CURRENT_TARGET_BASE_PATH + self.TARGET_MANAGER_PATH, "manager")
        for r,d,f in os.walk(self.CURRENT_TARGET_BASE_PATH + self.TARGET_MANAGER_PATH):
            os.chmod(r, stat.S_IRWXU | stat.S_IRWXG | stat.S_IRWXO)

    def cpShell(self):
        self.cpDir(self.CURRENT_SOURCE_BASE_PATH + self.SOURCE_SHELL_PATH,
                   self.CURRENT_TARGET_BASE_PATH + self.TARGET_SHELL_PATH, "shell")
        for r,d,f in os.walk(self.CURRENT_TARGET_BASE_PATH + self.TARGET_SHELL_PATH):
            os.chmod(r, stat.S_IRWXU | stat.S_IRWXG | stat.S_IRWXO)

    def cpFile(self, src, target):
        if (not os.path.isfile(src)):
            print(src + " is not a file")
            return
        path = os.path.dirname(target)
        if (not os.path.isdir(path)):
            os.makedirs(path)
        shutil.copy2(src, target)
        os.chmod(target, stat.S_IRWXU | stat.S_IRWXG | stat.S_IRWXO)


    def del_rw(self, action, name, exc):
        os.chmod(name, stat.S_IWRITE)
        os.remove(name)

    def cpDir(self, src, target, name):
        if (os.path.isdir(src) and not os.path.exists(target)):
            print("copy " + name + "  dir start")
            shutil.copytree(src, target)
            print("copy " + name + "  dir finish")
        else:
            if (not os.path.isdir(src)):
                print("source " + name + " path is not a dir")
            if (os.path.exists(target)):
                print ("target " + name + " path is exists")
                try:
                    shutil.rmtree(target, onerror=self.del_rw)
                except Exception, data:
                    print Exception, ":", data

                print ("target " + name + " dir destroyed")
                try:
                    shutil.copytree(src, target)
                except Exception, data:
                    print Exception, ":", data
                print("copy " + name + "  dir finish")

    def clear(self):
        self.setCurrentPath()
        try:
            shutil.rmtree(self.CURRENT_TARGET_BASE_PATH, onerror=self.del_rw)
        except Exception, data:
            print Exception, ":", data

    def cp(self):
        self.setCurrentPath()
        self.cpShell()
        self.cpManager()
        self.cpDoc()
        self.cpOtherFiles()
        self.cpPackage()
        self.cpSdb()
        self.cpResource()
        self.cpScript()
        self.cpTestKitLite()


parser = OptionParser()
parser.add_option("-i", "--install", dest="install", action="store_true", default=False,
                  help="copy folders and file into os")
parser.add_option("-p", "--purge", dest="clear", action="store_true", default=False,
                  help="clear all files")

(options, args) = parser.parse_args()
if (options.install):
    test = CpFile()
    test.cp()
elif(options.clear):
    test = CpFile()
    test.clear()
else:
    test = CpFile()
    test.cp()

